package ru.mai.dep806.catalog;

import java.util.LinkedList;

import org.hibernate.Session;
import ru.mai.dep806.catalog.model.*;
import ru.mai.dep806.catalog.util.HibernateUtil;

import java.util.Date;
import java.util.LinkedList;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: Eugene
 * Date: 29.03.12
 * Time: 16:17
 * To change this template use File | Settings | File Templates.
 */
public class CatalogTest {

    public static void main(String[] args) {
        // Получим сессию Hibernate
        Session session = ru.mai.dep806.catalog.util.HibernateUtil.getSession();

        // Начало транзакции
        session.beginTransaction();

        // Создание нового каталога и заполнение данными
        Catalog catalog = new Catalog();
        catalog.setName("Мой каталог №1");

        List<ru.mai.dep806.catalog.model.CatalogItem> items =
                new LinkedList<CatalogItem>();

        Author fauler = new Author();
        fauler.setName("Мартин Фаулер");
        fauler.setBirthdate(new Date());

        Author burton = new Author();
        burton.setName("Тим Бартон");
        burton.setBirthdate(new Date());

        BookItem book = new BookItem();
        book.setAuthor(fauler);
        book.setName("UML Основы");
        book.setISBN("1-232-12345-2");
        book.setCatalog(catalog);

        MovieItem movie = new MovieItem();
        movie.setAuthor(burton);
        movie.setName("Кошмар перед рождеством");
        movie.setGenre(MovieItem.MovieGenre.MUSIC);
        movie.setCatalog(catalog);

        items.add(book);
        items.add(movie);

        catalog.setItems(items);

        // Сохранение каталога в базу данных
        session.saveOrUpdate(catalog);
        // Завершение транзакции
        session.getTransaction().commit();

        System.out.println("Id=" + catalog.getId());

        // Вывод списка каталогов
        List<Catalog> list =
                (List<Catalog>) session.createQuery("select c from Catalog c where c.name like '%1%'").list();
//      (List<CatalogItem>) session.createQuery("select c from CatalogIten c where item.author.name like '%Гоголь%'").list();

//      List<Object> allObjects = session.createQuery("from Object");
        for (Catalog cat : list) {
            System.out.println(cat.getId() + " " + cat.getName());
            cat.getItems().get(0).getAuthor();
        }

    }
}
