package ru.mai.dep806.catalog.model;

import java.util.Date;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Id;

@javax.persistence.SequenceGenerator(
    name="SEQ_ID",
    sequenceName="SEQ_ID"
)
@Entity @Table(name="AUTHOR")
public class Author {
	private Long id;
	private String name;
	private Date birthdate;
	private List<CatalogItem> items;

	@Id @GeneratedValue(generator="SEQ_ID")
	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	
	@Column(name="NAME")
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	
	@Column(name="BIRTHDATE")
	public Date getBirthdate() {
		return birthdate;
	}
	public void setBirthdate(Date birthdate) {
		this.birthdate = birthdate;
	}
	
	@OneToMany(cascade=CascadeType.REFRESH, fetch=FetchType.LAZY)
	@JoinColumn(name="AUTHOR_ID")
	public List<CatalogItem> getItems() {
		return items;
	}
	public void setItems(List<CatalogItem> items) {
		this.items = items;
	}
	
	
	
}
